/* RDESC.CMD  executes MAKEDESC.BTM batch files created by ZDESC.CMD,   */
/*            restoring 4OS2 file descriptions.                         */
/*                                                                      */
/* Version 1.0 -- March 26, 1995 -- Gene Pizzetta, CompuServe 72060,505 */
/*    Initial release.                                                  */
/* Version 1.1 -- May 16, 1995 -- GP                                    */
/*    Did not restore current directory properly, if run from the root  */
/*    directory.                                                        */
/* Version 1.2 -- June 26, 1995 -- GP                                   */
/*    Modifications to CONV_VERS.  Added PRG_NAME.                      */

Call rxFuncAdd "SysLoadFuncs", "REXXUTIL", "SysLoadFuncs"
call sysloadfuncs

Vers = 12       /* current version */
SubVers = ' '   /* current revision level */

/* Parse option to a single letter "R" or "S", or garbage */
parse upper arg opt
if (pos('R',opt) <> 0) | (pos('S',opt) <> 0) then opt = translate(opt,,'-/')

if opt <> '' & opt <> 'S' & opt <> 'R' then
do
    say
    say 'RDESC    Version' CONV_VERS(Vers,1)SubVers
    say ''
    say 'Executes MAKEDESC.BTM files created by ZDESC to restore'
    say '4OS2 file descriptions.'
    say ''
    say 'Usage:'
    say
    say '  'PRG_NAME()' {S|R}'
    say
    say 'If the "S" or "R" option is given (either with or without'
    say 'a leading "/" or "-"), RDESC will recurse through all'
    say 'subdirectories below the current directory executing'
    say 'MAKEDESC.BTM files.'
    say ''
    exit
end

Bell = x2c(07)

signal on NOTREADY                      /* trap file errors */

OFile = 'MAKEDESC.BTM'

DirName ='*'
CurDir = directory()
CurDir = filespec('P',CurDir'\')
if CurDir = '\\' then CurDir = '\'

/* Do current directory */
call RSTDESC

if opt <> '' then call DOSUBS           /* Subdirectories were requested */

say ' RDESC Done.'
EXIT


/* ======================= Subroutines ======================= */


/* Do subdirectories */
/* ----------------- */

DOSUBS:

call SysFileTree DirName , 'Dirs' , 'DSO'

if Dirs.0 = 0 then RETURN

do j = 1 to Dirs.0
    NxtDir = filespec('P',Dirs.j'\')
    'cd' NxtDir
    call RSTDESC
end

'cd' CurDir

RETURN


/* Main subroutine for running MAKEDESC.BTM files */
/* ---------------------------------------------- */

RSTDESC:

say ' 'directory()

/* Make sure a MAKEDESC.BTM file exists */
call SysFileTree OFile , 'Files' , 'FO'
if Files.0 = 0 then
do
    say Bell'  "'OFile'" file not found'
    RETURN
end

/* Execute MAKEDESC.BTM file */

'*CALL' OFile

RETURN


/* Get the name of the current program */
/* ----------------------------------- */

PRG_NAME:

  parse source . . PName
  PName = filespec('name',PName)
  PName = left(PName,pos('.',PName)-1)

RETURN PName


/* Convert version number to correct format */
/* ---------------------------------------- */

CONV_VERS:

  arg PVers,OffSet
  OffSet = 10 ** OffSet
  PVers = PVers%OffSet'.'PVers//OffSet

RETURN PVers


/* Trap for file errors */
/* -------------------- */

NOTREADY:

say '  File error on line' sigl
say '  'sourceline(sigl)

EXIT

